include(fortran-interface.m4)

#include "dpFuncPtr.h"
#include <relax.h>
#include <restriction.h>
#include <relax-restrict.h>
#include <ipo-relax.h>
#include <stdlib.h>

int (*dpSmootherFuncPtr[DIME_SMOOTHER_METHOD_VARIANTS][DIME_FUNC_VARIANTS])(int *, int *, DIME_REAL *, int *,
 DIME_REAL *, int *, int *, DIME_REAL *, int *);

int (*dpRestrictionFuncPtr[DIME_RESTRICTION_METHOD_VARIANTS][DIME_FUNC_VARIANTS])(int *, int *, DIME_REAL *, int *, DIME_REAL *, int *,
 int *, int *, DIME_REAL *, int *, DIME_REAL *, int *, DIME_REAL *, 
 int *, DIME_REAL *);

int (*dpPreCoarseFuncPtr[DIME_SMOOTHER_METHOD_VARIANTS*DIME_RESTRICTION_METHOD_VARIANTS][DIME_FUNC_VARIANTS])(int *, int *, DIME_REAL *, int *, DIME_REAL *, int *, int *,
 int *, DIME_REAL *, int *, DIME_REAL *, int *, int *, DIME_REAL *, int *,
 DIME_REAL *);

int (*dpPostCoarseFuncPtr[DIME_SMOOTHER_METHOD_VARIANTS][DIME_FUNC_VARIANTS])(int *, int *, DIME_REAL *, int *, DIME_REAL *, int *, int *, int *, DIME_REAL *, int *,
 int *, DIME_REAL *, int *);

static void dpInitSmootherFuncPtrArray()
{
   dpSmootherFuncPtr[0][ 0]=dpF77FUNCTIONNAME(ssh5h1);
   dpSmootherFuncPtr[0][ 1]=dpF77FUNCTIONNAME(ssn5h1);
   dpSmootherFuncPtr[0][ 2]=dpF77FUNCTIONNAME(ssh5c1);
   dpSmootherFuncPtr[0][ 3]=dpF77FUNCTIONNAME(ssn5c1);
   dpSmootherFuncPtr[0][ 4]=dpF77FUNCTIONNAME(sgh5h1);
   dpSmootherFuncPtr[0][ 5]=dpF77FUNCTIONNAME(sgn5h1);
   dpSmootherFuncPtr[0][ 6]=dpF77FUNCTIONNAME(sgh5c1);
   dpSmootherFuncPtr[0][ 7]=dpF77FUNCTIONNAME(sgn5c1);
   dpSmootherFuncPtr[0][ 8]=dpF77FUNCTIONNAME(ssh9h1);
   dpSmootherFuncPtr[0][ 9]=dpF77FUNCTIONNAME(ssn9h1);
   dpSmootherFuncPtr[0][10]=dpF77FUNCTIONNAME(ssh9c1);
   dpSmootherFuncPtr[0][11]=dpF77FUNCTIONNAME(ssn9c1);
   dpSmootherFuncPtr[0][12]=dpF77FUNCTIONNAME(sgh9h1);
   dpSmootherFuncPtr[0][13]=dpF77FUNCTIONNAME(sgn9h1);
   dpSmootherFuncPtr[0][14]=dpF77FUNCTIONNAME(sgh9c1);
   dpSmootherFuncPtr[0][15]=dpF77FUNCTIONNAME(sgn9c1);

   dpSmootherFuncPtr[1][ 0]=dpF77FUNCTIONNAME(ssh5h2);
   dpSmootherFuncPtr[1][ 1]=dpF77FUNCTIONNAME(ssn5h2);
   dpSmootherFuncPtr[1][ 2]=dpF77FUNCTIONNAME(ssh5c2);
   dpSmootherFuncPtr[1][ 3]=dpF77FUNCTIONNAME(ssn5c2);
   dpSmootherFuncPtr[1][ 4]=dpF77FUNCTIONNAME(sgh5h2);
   dpSmootherFuncPtr[1][ 5]=dpF77FUNCTIONNAME(sgn5h2);
   dpSmootherFuncPtr[1][ 6]=dpF77FUNCTIONNAME(sgh5c2);
   dpSmootherFuncPtr[1][ 7]=dpF77FUNCTIONNAME(sgn5c2);
   dpSmootherFuncPtr[1][ 8]=dpF77FUNCTIONNAME(ssh9h2);
   dpSmootherFuncPtr[1][ 9]=dpF77FUNCTIONNAME(ssn9h2);
   dpSmootherFuncPtr[1][10]=dpF77FUNCTIONNAME(ssh9c2);
   dpSmootherFuncPtr[1][11]=dpF77FUNCTIONNAME(ssn9c2);
   dpSmootherFuncPtr[1][12]=dpF77FUNCTIONNAME(sgh9h2);
   dpSmootherFuncPtr[1][13]=dpF77FUNCTIONNAME(sgn9h2);
   dpSmootherFuncPtr[1][14]=dpF77FUNCTIONNAME(sgh9c2);
   dpSmootherFuncPtr[1][15]=dpF77FUNCTIONNAME(sgn9c2);

   dpSmootherFuncPtr[2][ 0]=dpF77FUNCTIONNAME(ssh5h3);
   dpSmootherFuncPtr[2][ 1]=dpF77FUNCTIONNAME(ssn5h3);
   dpSmootherFuncPtr[2][ 2]=dpF77FUNCTIONNAME(ssh5c3);
   dpSmootherFuncPtr[2][ 3]=dpF77FUNCTIONNAME(ssn5c3);
   dpSmootherFuncPtr[2][ 4]=dpF77FUNCTIONNAME(sgh5h3);
   dpSmootherFuncPtr[2][ 5]=dpF77FUNCTIONNAME(sgn5h3);
   dpSmootherFuncPtr[2][ 6]=dpF77FUNCTIONNAME(sgh5c3);
   dpSmootherFuncPtr[2][ 7]=dpF77FUNCTIONNAME(sgn5c3);
   dpSmootherFuncPtr[2][ 8]=dpF77FUNCTIONNAME(ssh9h3);
   dpSmootherFuncPtr[2][ 9]=dpF77FUNCTIONNAME(ssn9h3);
   dpSmootherFuncPtr[2][10]=dpF77FUNCTIONNAME(ssh9c3);
   dpSmootherFuncPtr[2][11]=dpF77FUNCTIONNAME(ssn9c3);
   dpSmootherFuncPtr[2][12]=dpF77FUNCTIONNAME(sgh9h3);
   dpSmootherFuncPtr[2][13]=dpF77FUNCTIONNAME(sgn9h3);
   dpSmootherFuncPtr[2][14]=dpF77FUNCTIONNAME(sgh9c3);
   dpSmootherFuncPtr[2][15]=dpF77FUNCTIONNAME(sgn9c3);

   dpSmootherFuncPtr[3][ 0]=dpF77FUNCTIONNAME(ssh5h4);
   dpSmootherFuncPtr[3][ 1]=dpF77FUNCTIONNAME(ssn5h4);
   dpSmootherFuncPtr[3][ 2]=dpF77FUNCTIONNAME(ssh5c4);
   dpSmootherFuncPtr[3][ 3]=dpF77FUNCTIONNAME(ssn5c4);
   dpSmootherFuncPtr[3][ 4]=dpF77FUNCTIONNAME(sgh5h4);
   dpSmootherFuncPtr[3][ 5]=dpF77FUNCTIONNAME(sgn5h4);
   dpSmootherFuncPtr[3][ 6]=dpF77FUNCTIONNAME(sgh5c4);
   dpSmootherFuncPtr[3][ 7]=dpF77FUNCTIONNAME(sgn5c4);
   dpSmootherFuncPtr[3][ 8]=dpF77FUNCTIONNAME(ssh9h4);
   dpSmootherFuncPtr[3][ 9]=dpF77FUNCTIONNAME(ssn9h4);
   dpSmootherFuncPtr[3][10]=dpF77FUNCTIONNAME(ssh9c4);
   dpSmootherFuncPtr[3][11]=dpF77FUNCTIONNAME(ssn9c4);
   dpSmootherFuncPtr[3][12]=dpF77FUNCTIONNAME(sgh9h4);
   dpSmootherFuncPtr[3][13]=dpF77FUNCTIONNAME(sgn9h4);
   dpSmootherFuncPtr[3][14]=dpF77FUNCTIONNAME(sgh9c4);
   dpSmootherFuncPtr[3][15]=dpF77FUNCTIONNAME(sgn9c4);
}

static void dpInitRestrictionFuncPtrArray()
{
   dpRestrictionFuncPtr[0][ 0]=dpF77FUNCTIONNAME(rsh5h1);
   dpRestrictionFuncPtr[0][ 1]=dpF77FUNCTIONNAME(rsn5h1);
   dpRestrictionFuncPtr[0][ 2]=dpF77FUNCTIONNAME(rsh5c1);
   dpRestrictionFuncPtr[0][ 3]=dpF77FUNCTIONNAME(rsn5c1);
   dpRestrictionFuncPtr[0][ 4]=dpF77FUNCTIONNAME(rgh5h1);
   dpRestrictionFuncPtr[0][ 5]=dpF77FUNCTIONNAME(rgn5h1);
   dpRestrictionFuncPtr[0][ 6]=dpF77FUNCTIONNAME(rgh5c1);
   dpRestrictionFuncPtr[0][ 7]=dpF77FUNCTIONNAME(rgn5c1);
   dpRestrictionFuncPtr[0][ 8]=dpF77FUNCTIONNAME(rsh9h1);
   dpRestrictionFuncPtr[0][ 9]=dpF77FUNCTIONNAME(rsn9h1);
   dpRestrictionFuncPtr[0][10]=dpF77FUNCTIONNAME(rsh9c1);
   dpRestrictionFuncPtr[0][11]=dpF77FUNCTIONNAME(rsn9c1);
   dpRestrictionFuncPtr[0][12]=dpF77FUNCTIONNAME(rgh9h1);
   dpRestrictionFuncPtr[0][13]=dpF77FUNCTIONNAME(rgn9h1);
   dpRestrictionFuncPtr[0][14]=dpF77FUNCTIONNAME(rgh9c1);
   dpRestrictionFuncPtr[0][15]=dpF77FUNCTIONNAME(rgn9c1);

   dpRestrictionFuncPtr[1][ 0]=dpF77FUNCTIONNAME(rsh5h2);
   dpRestrictionFuncPtr[1][ 1]=dpF77FUNCTIONNAME(rsn5h2);
   dpRestrictionFuncPtr[1][ 2]=dpF77FUNCTIONNAME(rsh5c2);
   dpRestrictionFuncPtr[1][ 3]=dpF77FUNCTIONNAME(rsn5c2);
   dpRestrictionFuncPtr[1][ 4]=dpF77FUNCTIONNAME(rgh5h2);
   dpRestrictionFuncPtr[1][ 5]=dpF77FUNCTIONNAME(rgn5h2);
   dpRestrictionFuncPtr[1][ 6]=dpF77FUNCTIONNAME(rgh5c2);
   dpRestrictionFuncPtr[1][ 7]=dpF77FUNCTIONNAME(rgn5c2);
   dpRestrictionFuncPtr[1][ 8]=dpF77FUNCTIONNAME(rsh9h2);
   dpRestrictionFuncPtr[1][ 9]=dpF77FUNCTIONNAME(rsn9h2);
   dpRestrictionFuncPtr[1][10]=dpF77FUNCTIONNAME(rsh9c2);
   dpRestrictionFuncPtr[1][11]=dpF77FUNCTIONNAME(rsn9c2);
   dpRestrictionFuncPtr[1][12]=dpF77FUNCTIONNAME(rgh9h2);
   dpRestrictionFuncPtr[1][13]=dpF77FUNCTIONNAME(rgn9h2);
   dpRestrictionFuncPtr[1][14]=dpF77FUNCTIONNAME(rgh9c2);
   dpRestrictionFuncPtr[1][15]=dpF77FUNCTIONNAME(rgn9c2);
}

static void dpInitPreCoarseFuncPtrArray()
{
   dpPreCoarseFuncPtr[0][ 0]=NULL;
   dpPreCoarseFuncPtr[0][ 1]=NULL;
   dpPreCoarseFuncPtr[0][ 2]=NULL;
   dpPreCoarseFuncPtr[0][ 3]=NULL;
   dpPreCoarseFuncPtr[0][ 4]=NULL;
   dpPreCoarseFuncPtr[0][ 5]=NULL;
   dpPreCoarseFuncPtr[0][ 6]=NULL;
   dpPreCoarseFuncPtr[0][ 7]=NULL;
   dpPreCoarseFuncPtr[0][ 8]=NULL;
   dpPreCoarseFuncPtr[0][ 9]=NULL;
   dpPreCoarseFuncPtr[0][10]=NULL;
   dpPreCoarseFuncPtr[0][11]=NULL;
   dpPreCoarseFuncPtr[0][12]=NULL;
   dpPreCoarseFuncPtr[0][13]=NULL;
   dpPreCoarseFuncPtr[0][14]=NULL;
   dpPreCoarseFuncPtr[0][15]=NULL;

   dpPreCoarseFuncPtr[1][ 0]=dpF77FUNCTIONNAME(hsh5h2);
   dpPreCoarseFuncPtr[1][ 1]=dpF77FUNCTIONNAME(hsn5h2);
   dpPreCoarseFuncPtr[1][ 2]=dpF77FUNCTIONNAME(hsh5c2);
   dpPreCoarseFuncPtr[1][ 3]=dpF77FUNCTIONNAME(hsn5c2);
   dpPreCoarseFuncPtr[1][ 4]=dpF77FUNCTIONNAME(hgh5h2);
   dpPreCoarseFuncPtr[1][ 5]=dpF77FUNCTIONNAME(hgn5h2);
   dpPreCoarseFuncPtr[1][ 6]=dpF77FUNCTIONNAME(hgh5c2);
   dpPreCoarseFuncPtr[1][ 7]=dpF77FUNCTIONNAME(hgn5c2);
   dpPreCoarseFuncPtr[1][ 8]=dpF77FUNCTIONNAME(hsh9h2);
   dpPreCoarseFuncPtr[1][ 9]=dpF77FUNCTIONNAME(hsn9h2);
   dpPreCoarseFuncPtr[1][10]=dpF77FUNCTIONNAME(hsh9c2);
   dpPreCoarseFuncPtr[1][11]=dpF77FUNCTIONNAME(hsn9c2);
   dpPreCoarseFuncPtr[1][12]=dpF77FUNCTIONNAME(hgh9h2);
   dpPreCoarseFuncPtr[1][13]=dpF77FUNCTIONNAME(hgn9h2);
   dpPreCoarseFuncPtr[1][14]=dpF77FUNCTIONNAME(hgh9c2);
   dpPreCoarseFuncPtr[1][15]=dpF77FUNCTIONNAME(hgn9c2);

   dpPreCoarseFuncPtr[2][ 0]=dpF77FUNCTIONNAME(hsh5h3);
   dpPreCoarseFuncPtr[2][ 1]=dpF77FUNCTIONNAME(hsn5h3);
   dpPreCoarseFuncPtr[2][ 2]=dpF77FUNCTIONNAME(hsh5c3);
   dpPreCoarseFuncPtr[2][ 3]=dpF77FUNCTIONNAME(hsn5c3);
   dpPreCoarseFuncPtr[2][ 4]=dpF77FUNCTIONNAME(hgh5h3);
   dpPreCoarseFuncPtr[2][ 5]=dpF77FUNCTIONNAME(hgn5h3);
   dpPreCoarseFuncPtr[2][ 6]=dpF77FUNCTIONNAME(hgh5c3);
   dpPreCoarseFuncPtr[2][ 7]=dpF77FUNCTIONNAME(hgn5c3);
   dpPreCoarseFuncPtr[2][ 8]=dpF77FUNCTIONNAME(hsh9h3);
   dpPreCoarseFuncPtr[2][ 9]=dpF77FUNCTIONNAME(hsn9h3);
   dpPreCoarseFuncPtr[2][10]=dpF77FUNCTIONNAME(hsh9c3);
   dpPreCoarseFuncPtr[2][11]=dpF77FUNCTIONNAME(hsn9c3);
   dpPreCoarseFuncPtr[2][12]=dpF77FUNCTIONNAME(hgh9h3);
   dpPreCoarseFuncPtr[2][13]=dpF77FUNCTIONNAME(hgn9h3);
   dpPreCoarseFuncPtr[2][14]=dpF77FUNCTIONNAME(hgh9c3);
   dpPreCoarseFuncPtr[2][15]=dpF77FUNCTIONNAME(hgn9c3);

   dpPreCoarseFuncPtr[3][ 0]=dpF77FUNCTIONNAME(hsh5h4);
   dpPreCoarseFuncPtr[3][ 1]=dpF77FUNCTIONNAME(hsn5h4);
   dpPreCoarseFuncPtr[3][ 2]=dpF77FUNCTIONNAME(hsh5c4);
   dpPreCoarseFuncPtr[3][ 3]=dpF77FUNCTIONNAME(hsn5c4);
   dpPreCoarseFuncPtr[3][ 4]=dpF77FUNCTIONNAME(hgh5h4);
   dpPreCoarseFuncPtr[3][ 5]=dpF77FUNCTIONNAME(hgn5h4);
   dpPreCoarseFuncPtr[3][ 6]=dpF77FUNCTIONNAME(hgh5c4);
   dpPreCoarseFuncPtr[3][ 7]=dpF77FUNCTIONNAME(hgn5c4);
   dpPreCoarseFuncPtr[3][ 8]=dpF77FUNCTIONNAME(hsh9h4);
   dpPreCoarseFuncPtr[3][ 9]=dpF77FUNCTIONNAME(hsn9h4);
   dpPreCoarseFuncPtr[3][10]=dpF77FUNCTIONNAME(hsh9c4);
   dpPreCoarseFuncPtr[3][11]=dpF77FUNCTIONNAME(hsn9c4);
   dpPreCoarseFuncPtr[3][12]=dpF77FUNCTIONNAME(hgh9h4);
   dpPreCoarseFuncPtr[3][13]=dpF77FUNCTIONNAME(hgn9h4);
   dpPreCoarseFuncPtr[3][14]=dpF77FUNCTIONNAME(hgh9c4);
   dpPreCoarseFuncPtr[3][15]=dpF77FUNCTIONNAME(hgn9c4);

   dpPreCoarseFuncPtr[4][ 0]=NULL;
   dpPreCoarseFuncPtr[4][ 1]=NULL;
   dpPreCoarseFuncPtr[4][ 2]=NULL;
   dpPreCoarseFuncPtr[4][ 3]=NULL;
   dpPreCoarseFuncPtr[4][ 4]=NULL;
   dpPreCoarseFuncPtr[4][ 5]=NULL;
   dpPreCoarseFuncPtr[4][ 6]=NULL;
   dpPreCoarseFuncPtr[4][ 7]=NULL;
   dpPreCoarseFuncPtr[4][ 8]=NULL;
   dpPreCoarseFuncPtr[4][ 9]=NULL;
   dpPreCoarseFuncPtr[4][10]=NULL;
   dpPreCoarseFuncPtr[4][11]=NULL;
   dpPreCoarseFuncPtr[4][12]=NULL;
   dpPreCoarseFuncPtr[4][13]=NULL;
   dpPreCoarseFuncPtr[4][14]=NULL;
   dpPreCoarseFuncPtr[4][15]=NULL;

   dpPreCoarseFuncPtr[5][ 0]=dpF77FUNCTIONNAME(fsh5h2);
   dpPreCoarseFuncPtr[5][ 1]=dpF77FUNCTIONNAME(fsn5h2);
   dpPreCoarseFuncPtr[5][ 2]=dpF77FUNCTIONNAME(fsh5c2);
   dpPreCoarseFuncPtr[5][ 3]=dpF77FUNCTIONNAME(fsn5c2);
   dpPreCoarseFuncPtr[5][ 4]=dpF77FUNCTIONNAME(fgh5h2);
   dpPreCoarseFuncPtr[5][ 5]=dpF77FUNCTIONNAME(fgn5h2);
   dpPreCoarseFuncPtr[5][ 6]=dpF77FUNCTIONNAME(fgh5c2);
   dpPreCoarseFuncPtr[5][ 7]=dpF77FUNCTIONNAME(fgn5c2);
   dpPreCoarseFuncPtr[5][ 8]=dpF77FUNCTIONNAME(fsh9h2);
   dpPreCoarseFuncPtr[5][ 9]=dpF77FUNCTIONNAME(fsn9h2);
   dpPreCoarseFuncPtr[5][10]=dpF77FUNCTIONNAME(fsh9c2);
   dpPreCoarseFuncPtr[5][11]=dpF77FUNCTIONNAME(fsn9c2);
   dpPreCoarseFuncPtr[5][12]=dpF77FUNCTIONNAME(fgh9h2);
   dpPreCoarseFuncPtr[5][13]=dpF77FUNCTIONNAME(fgn9h2);
   dpPreCoarseFuncPtr[5][14]=dpF77FUNCTIONNAME(fgh9c2);
   dpPreCoarseFuncPtr[5][15]=dpF77FUNCTIONNAME(fgn9c2);

   dpPreCoarseFuncPtr[6][ 0]=dpF77FUNCTIONNAME(fsh5h3);
   dpPreCoarseFuncPtr[6][ 1]=dpF77FUNCTIONNAME(fsn5h3);
   dpPreCoarseFuncPtr[6][ 2]=dpF77FUNCTIONNAME(fsh5c3);
   dpPreCoarseFuncPtr[6][ 3]=dpF77FUNCTIONNAME(fsn5c3);
   dpPreCoarseFuncPtr[6][ 4]=dpF77FUNCTIONNAME(fgh5h3);
   dpPreCoarseFuncPtr[6][ 5]=dpF77FUNCTIONNAME(fgn5h3);
   dpPreCoarseFuncPtr[6][ 6]=dpF77FUNCTIONNAME(fgh5c3);
   dpPreCoarseFuncPtr[6][ 7]=dpF77FUNCTIONNAME(fgn5c3);
   dpPreCoarseFuncPtr[6][ 8]=dpF77FUNCTIONNAME(fsh9h3);
   dpPreCoarseFuncPtr[6][ 9]=dpF77FUNCTIONNAME(fsn9h3);
   dpPreCoarseFuncPtr[6][10]=dpF77FUNCTIONNAME(fsh9c3);
   dpPreCoarseFuncPtr[6][11]=dpF77FUNCTIONNAME(fsn9c3);
   dpPreCoarseFuncPtr[6][12]=dpF77FUNCTIONNAME(fgh9h3);
   dpPreCoarseFuncPtr[6][13]=dpF77FUNCTIONNAME(fgn9h3);
   dpPreCoarseFuncPtr[6][14]=dpF77FUNCTIONNAME(fgh9c3);
   dpPreCoarseFuncPtr[6][15]=dpF77FUNCTIONNAME(fgn9c3);

   dpPreCoarseFuncPtr[7][ 0]=dpF77FUNCTIONNAME(fsh5h4);
   dpPreCoarseFuncPtr[7][ 1]=dpF77FUNCTIONNAME(fsn5h4);
   dpPreCoarseFuncPtr[7][ 2]=dpF77FUNCTIONNAME(fsh5c4);
   dpPreCoarseFuncPtr[7][ 3]=dpF77FUNCTIONNAME(fsn5c4);
   dpPreCoarseFuncPtr[7][ 4]=dpF77FUNCTIONNAME(fgh5h4);
   dpPreCoarseFuncPtr[7][ 5]=dpF77FUNCTIONNAME(fgn5h4);
   dpPreCoarseFuncPtr[7][ 6]=dpF77FUNCTIONNAME(fgh5c4);
   dpPreCoarseFuncPtr[7][ 7]=dpF77FUNCTIONNAME(fgn5c4);
   dpPreCoarseFuncPtr[7][ 8]=dpF77FUNCTIONNAME(fsh9h4);
   dpPreCoarseFuncPtr[7][ 9]=dpF77FUNCTIONNAME(fsn9h4);
   dpPreCoarseFuncPtr[7][10]=dpF77FUNCTIONNAME(fsh9c4);
   dpPreCoarseFuncPtr[7][11]=dpF77FUNCTIONNAME(fsn9c4);
   dpPreCoarseFuncPtr[7][12]=dpF77FUNCTIONNAME(fgh9h4);
   dpPreCoarseFuncPtr[7][13]=dpF77FUNCTIONNAME(fgn9h4);
   dpPreCoarseFuncPtr[7][14]=dpF77FUNCTIONNAME(fgh9c4);
   dpPreCoarseFuncPtr[7][15]=dpF77FUNCTIONNAME(fgn9c4);
}

static void dpInitPostCoarseFuncPtrArray()
{
   dpPostCoarseFuncPtr[0][ 0]=NULL;
   dpPostCoarseFuncPtr[0][ 1]=NULL;
   dpPostCoarseFuncPtr[0][ 2]=NULL;
   dpPostCoarseFuncPtr[0][ 3]=NULL;
   dpPostCoarseFuncPtr[0][ 4]=NULL;
   dpPostCoarseFuncPtr[0][ 5]=NULL;
   dpPostCoarseFuncPtr[0][ 6]=NULL;
   dpPostCoarseFuncPtr[0][ 7]=NULL;
   dpPostCoarseFuncPtr[0][ 8]=NULL;
   dpPostCoarseFuncPtr[0][ 9]=NULL;
   dpPostCoarseFuncPtr[0][10]=NULL;
   dpPostCoarseFuncPtr[0][11]=NULL;
   dpPostCoarseFuncPtr[0][12]=NULL;
   dpPostCoarseFuncPtr[0][13]=NULL;
   dpPostCoarseFuncPtr[0][14]=NULL;
   dpPostCoarseFuncPtr[0][15]=NULL;

   dpPostCoarseFuncPtr[1][ 0]=dpF77FUNCTIONNAME(osh5h2);
   dpPostCoarseFuncPtr[1][ 1]=dpF77FUNCTIONNAME(osn5h2);
   dpPostCoarseFuncPtr[1][ 2]=dpF77FUNCTIONNAME(osh5c2);
   dpPostCoarseFuncPtr[1][ 3]=dpF77FUNCTIONNAME(osn5c2);
   dpPostCoarseFuncPtr[1][ 4]=dpF77FUNCTIONNAME(ogh5h2);
   dpPostCoarseFuncPtr[1][ 5]=dpF77FUNCTIONNAME(ogn5h2);
   dpPostCoarseFuncPtr[1][ 6]=dpF77FUNCTIONNAME(ogh5c2);
   dpPostCoarseFuncPtr[1][ 7]=dpF77FUNCTIONNAME(ogn5c2);
   dpPostCoarseFuncPtr[1][ 8]=dpF77FUNCTIONNAME(osh9h2);
   dpPostCoarseFuncPtr[1][ 9]=dpF77FUNCTIONNAME(osn9h2);
   dpPostCoarseFuncPtr[1][10]=dpF77FUNCTIONNAME(osh9c2);
   dpPostCoarseFuncPtr[1][11]=dpF77FUNCTIONNAME(osn9c2);
   dpPostCoarseFuncPtr[1][12]=dpF77FUNCTIONNAME(ogh9h2);
   dpPostCoarseFuncPtr[1][13]=dpF77FUNCTIONNAME(ogn9h2);
   dpPostCoarseFuncPtr[1][14]=dpF77FUNCTIONNAME(ogh9c2);
   dpPostCoarseFuncPtr[1][15]=dpF77FUNCTIONNAME(ogn9c2);

   dpPostCoarseFuncPtr[2][ 0]=dpF77FUNCTIONNAME(osh5h3);
   dpPostCoarseFuncPtr[2][ 1]=dpF77FUNCTIONNAME(osn5h3);
   dpPostCoarseFuncPtr[2][ 2]=dpF77FUNCTIONNAME(osh5c3);
   dpPostCoarseFuncPtr[2][ 3]=dpF77FUNCTIONNAME(osn5c3);
   dpPostCoarseFuncPtr[2][ 4]=dpF77FUNCTIONNAME(ogh5h3);
   dpPostCoarseFuncPtr[2][ 5]=dpF77FUNCTIONNAME(ogn5h3);
   dpPostCoarseFuncPtr[2][ 6]=dpF77FUNCTIONNAME(ogh5c3);
   dpPostCoarseFuncPtr[2][ 7]=dpF77FUNCTIONNAME(ogn5c3);
   dpPostCoarseFuncPtr[2][ 8]=dpF77FUNCTIONNAME(osh9h3);
   dpPostCoarseFuncPtr[2][ 9]=dpF77FUNCTIONNAME(osn9h3);
   dpPostCoarseFuncPtr[2][10]=dpF77FUNCTIONNAME(osh9c3);
   dpPostCoarseFuncPtr[2][11]=dpF77FUNCTIONNAME(osn9c3);
   dpPostCoarseFuncPtr[2][12]=dpF77FUNCTIONNAME(ogh9h3);
   dpPostCoarseFuncPtr[2][13]=dpF77FUNCTIONNAME(ogn9h3);
   dpPostCoarseFuncPtr[2][14]=dpF77FUNCTIONNAME(ogh9c3);
   dpPostCoarseFuncPtr[2][15]=dpF77FUNCTIONNAME(ogn9c3);

   dpPostCoarseFuncPtr[3][ 0]=dpF77FUNCTIONNAME(osh5h4);
   dpPostCoarseFuncPtr[3][ 1]=dpF77FUNCTIONNAME(osn5h4);
   dpPostCoarseFuncPtr[3][ 2]=dpF77FUNCTIONNAME(osh5c4);
   dpPostCoarseFuncPtr[3][ 3]=dpF77FUNCTIONNAME(osn5c4);
   dpPostCoarseFuncPtr[3][ 4]=dpF77FUNCTIONNAME(ogh5h4);
   dpPostCoarseFuncPtr[3][ 5]=dpF77FUNCTIONNAME(ogn5h4);
   dpPostCoarseFuncPtr[3][ 6]=dpF77FUNCTIONNAME(ogh5c4);
   dpPostCoarseFuncPtr[3][ 7]=dpF77FUNCTIONNAME(ogn5c4);
   dpPostCoarseFuncPtr[3][ 8]=dpF77FUNCTIONNAME(osh9h4);
   dpPostCoarseFuncPtr[3][ 9]=dpF77FUNCTIONNAME(osn9h4);
   dpPostCoarseFuncPtr[3][10]=dpF77FUNCTIONNAME(osh9c4);
   dpPostCoarseFuncPtr[3][11]=dpF77FUNCTIONNAME(osn9c4);
   dpPostCoarseFuncPtr[3][12]=dpF77FUNCTIONNAME(ogh9h4);
   dpPostCoarseFuncPtr[3][13]=dpF77FUNCTIONNAME(ogn9h4);
   dpPostCoarseFuncPtr[3][14]=dpF77FUNCTIONNAME(ogh9c4);
   dpPostCoarseFuncPtr[3][15]=dpF77FUNCTIONNAME(ogn9c4);
}

void dpInitFuncPtrArray()
{
  dpInitSmootherFuncPtrArray();
  dpInitRestrictionFuncPtrArray();
  dpInitPreCoarseFuncPtrArray();
  dpInitPostCoarseFuncPtrArray();
}

