include(general.m4)
include(relax.m4)
include(post2.m4)
include(post3.m4)
include(post4.m4)
include(postheader.m4)

C#-----------------------------------------------------------
C# define 9P solver for fused red-black Gauss-Seidel smoother
C#-----------------------------------------------------------

undefine(`RB_KERN')
define(RB_KERN,RED_BLACK_FUSED)

define(`relax',`relax_s_h_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_h_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_h_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_h_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_h_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_h_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_h_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_h_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_h_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(osh9c2)

define(`relax',`relax_g_h_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_h_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_h_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_h_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_h_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_h_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_h_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_h_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_h_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(ogh9c2)

define(`relax',`relax_s_n_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_n_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_n_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_n_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_n_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_n_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_n_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_n_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_n_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(osn9c2)

define(`relax',`relax_g_n_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_n_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_n_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_n_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_n_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_n_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_n_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_n_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_n_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(ogn9c2)

define(`relax',`relax_s_h_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_h_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_h_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_h_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_h_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_h_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_h_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_h_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_h_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(osh9h2)

define(`relax',`relax_g_h_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_h_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_h_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_h_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_h_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_h_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_h_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_h_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_h_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(ogh9h2)

define(`relax',`relax_s_n_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_n_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_n_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_n_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_n_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_n_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_n_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_n_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_n_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(osn9h2)

define(`relax',`relax_g_n_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_n_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_n_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_n_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_n_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_n_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_n_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_n_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_n_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(ogn9h2)

C#----------------------------------------------------------------
C# define 9P solver for 1D blocked red-black Gauss-Seidel smoother
C#-----------------------------------------------------------------

undefine(`RB_KERN')
define(RB_KERN,RED_BLACK_1DBLOCKED)

define(`relax',`relax_s_h_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_h_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_h_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_h_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_h_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_h_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_h_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_h_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_h_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(osh9c3)

define(`relax',`relax_g_h_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_h_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_h_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_h_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_h_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_h_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_h_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_h_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_h_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(ogh9c3)

define(`relax',`relax_s_n_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_n_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_n_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_n_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_n_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_n_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_n_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_n_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_n_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(osn9c3)

define(`relax',`relax_g_n_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_n_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_n_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_n_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_n_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_n_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_n_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_n_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_n_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(ogn9c3)

define(`relax',`relax_s_h_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_h_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_h_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_h_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_h_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_h_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_h_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_h_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_h_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(osh9h3)

define(`relax',`relax_g_h_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_h_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_h_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_h_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_h_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_h_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_h_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_h_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_h_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(ogh9h3)

define(`relax',`relax_s_n_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_n_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_n_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_n_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_n_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_n_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_n_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_n_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_n_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(osn9h3)

define(`relax',`relax_g_n_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_n_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_n_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_n_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_n_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_n_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_n_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_n_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_n_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(ogn9h3)

C#-----------------------------------------------------------------------
C# define 9P solver for 2D skewed blocked red-black Gauss-Seidel smoother
C#-----------------------------------------------------------------------

undefine(`RB_KERN')
define(RB_KERN,RED_BLACK_2DBLOCKED_SKEWED)

define(`relax',`relax_s_h_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_h_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_h_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_h_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_h_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_h_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_h_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_h_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_h_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(osh9c4)

define(`relax',`relax_g_h_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_h_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_h_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_h_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_h_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_h_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_h_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_h_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_h_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(ogh9c4)

define(`relax',`relax_s_n_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_n_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_n_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_n_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_n_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_n_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_n_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_n_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_n_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(osn9c4)

define(`relax',`relax_g_n_9_c($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_n_9_c($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_n_9_c($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_n_9_c($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_n_9_c($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_n_9_c($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_n_9_c($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_n_9_c($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_n_9_c($1,$2)')
SUBROUTINE_DIME_RB_9P(ogn9c4)

define(`relax',`relax_s_h_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_h_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_h_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_h_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_h_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_h_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_h_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_h_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_h_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(osh9h4)

define(`relax',`relax_g_h_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_h_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_h_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_h_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_h_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_h_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_h_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_h_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_h_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(ogh9h4)

define(`relax',`relax_s_n_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_s_n_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_s_n_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_s_n_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_s_n_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_s_n_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_s_n_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_s_n_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_s_n_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(osn9h4)

define(`relax',`relax_g_n_9_h($1,$2)')
define(`relax_no_boundary',`relax_no_boundary_g_n_9_h($1,$2)')
define(`relax_ne_boundary',`relax_ne_boundary_g_n_9_h($1,$2)')
define(`relax_ea_boundary',`relax_ea_boundary_g_n_9_h($1,$2)')
define(`relax_se_boundary',`relax_se_boundary_g_n_9_h($1,$2)')
define(`relax_so_boundary',`relax_so_boundary_g_n_9_h($1,$2)')
define(`relax_sw_boundary',`relax_sw_boundary_g_n_9_h($1,$2)')
define(`relax_we_boundary',`relax_we_boundary_g_n_9_h($1,$2)')
define(`relax_nw_boundary',`relax_nw_boundary_g_n_9_h($1,$2)')
SUBROUTINE_DIME_RB_9P(ogn9h4)
