C#-------------------------------------
C# definition of restriction operations
C#-------------------------------------

undefine(RESTRICT_NO_BOUNDARY_EVEN)
undefine(RESTRICT_NE_BOUNDARY_EVEN)
undefine(RESTRICT_EA_BOUNDARY_EVEN)
undefine(RESTRICT_SE_BOUNDARY_EVEN)
undefine(RESTRICT_SO_BOUNDARY_EVEN)
undefine(RESTRICT_SW_BOUNDARY_EVEN)
undefine(RESTRICT_WE_BOUNDARY_EVEN)
undefine(RESTRICT_NW_BOUNDARY_EVEN)
undefine(RESTRICT_EVEN)
undefine(RESTRICT_ODD)
undefine(RESTRICT_NEAR_NO_ODD)
undefine(RESTRICT_NEAR_NE_ODD)
undefine(RESTRICT_NEAR_EA_ODD)
undefine(RESTRICT_NEAR_SE_ODD)
undefine(RESTRICT_NEAR_SO_ODD)
undefine(RESTRICT_NEAR_SW_ODD)
undefine(RESTRICT_NEAR_WE_ODD)
undefine(RESTRICT_NEAR_NW_ODD)

define(`RESTRICT_NO_BOUNDARY_EVEN',`
C#        `print *,"R (NO)",$1,",",$2'
	fc(($1)/2,nypc-1)=residual_no_boundary($1,nyp-1)*1.0
        fc(($1)/2,nypc-1)=fc(($1)/2,nypc-1)+residual($1-1,nyp-2)*0.5
        fc(($1)/2,nypc-1)=fc(($1)/2,nypc-1)+residual($1+1,nyp-2)*0.5')

define(`RESTRICT_NE_BOUNDARY_EVEN',`
C#        `print *,"R (NE)",$1,",",$2'
	fc(nxpc-1,nypc-1)=residual_ne_boundary(nxp-1,nyp-1)*1.0
        fc(nxpc-1,nypc-1)=fc(nxpc-1,nypc-1)+residual(nxp-2,nyp-2)*1.0')

define(`RESTRICT_EA_BOUNDARY_EVEN',`
C#        `print *,"R (EA)",$1,",",$2'
	fc(nxpc-1,($2)/2)=residual_ea_boundary(nxp-1,$2)*1.0
        fc(nxpc-1,($2)/2)=fc(nxpc-1,($2)/2)+residual(nxp-2,$2-1)*0.5
        fc(nxpc-1,($2)/2)=fc(nxpc-1,($2)/2)+residual(nxp-2,$2+1)*0.5')

define(`RESTRICT_SE_BOUNDARY_EVEN',`
C#        `print *,"R (SE)",$1,",",$2'
	fc(nxpc-1,0)=residual_se_boundary(nxp-1,0)*1.0
        fc(nxpc-1,0)=fc(nxpc-1,0)+residual(nxp-2,1)*1.0')

define(`RESTRICT_SO_BOUNDARY_EVEN',`
C#        `print *,"R (SO)",$1,",",$2'
	fc(($1)/2,0)=residual_so_boundary($1,0)*1.0
        fc(($1)/2,0)=fc(($1)/2,0)+residual($1-1,1)*0.5
        fc(($1)/2,0)=fc(($1)/2,0)+residual($1+1,1)*0.5')

define(`RESTRICT_SW_BOUNDARY_EVEN',`
C#        `print *,"R (SW)",$1,",",$2'
	fc(0,0)=residual_sw_boundary(0,0)*1.0
        fc(0,0)=fc(0,0)+residual(1,1)*1.0')

define(`RESTRICT_WE_BOUNDARY_EVEN',`
C#        `print *,"R (WE)",$1,",",$2'
	fc(0,($2)/2)=residual_we_boundary(0,$2)*1.0
        fc(0,($2)/2)=fc(0,($2)/2)+residual(1,$2-1)*0.5
        fc(0,($2)/2)=fc(0,($2)/2)+residual(1,$2+1)*0.5')

define(`RESTRICT_NW_BOUNDARY_EVEN',`
C#        `print *,"R (NW)",$1,",",$2'
	fc(0,nypc-1)=residual_nw_boundary(0,nyp-1)*1.0
        fc(0,nypc-1)=fc(0,nypc-1)+residual(1,nyp-2)*1.0')

define(`RESTRICT_EVEN',`
C#        `print *,"R (EVEN)",$1,",",$2'
	fc(($1)/2,($2)/2)=fc(($1)/2,($2)/2)+residual($1,$2)/1.0')

define(`RESTRICT_ODD',`
C#        `print *,"R (ODD)",$1,",",$2'
	fc(($1)/2,($2)/2)=fc(($1)/2,($2)/2)+residual($1,$2)/4.0
	fc(($1)/2+1,($2)/2)=fc(($1)/2+1,($2)/2)+residual($1,$2)/4.0
	fc(($1)/2,($2)/2+1)=fc(($1)/2,($2)/2+1)+residual($1,$2)/4.0
	fc(($1)/2+1,($2)/2+1)=residual($1,$2)/4.0')

define(`RESTRICT_NEAR_NO_ODD',`
C#        `print *,"R (N-NO)",$1,",",$2'
	fc(($1)/2,nypc-2)=fc(($1)/2,nypc-2)+residual($1,nyp-2)/4.0
	fc(($1)/2+1,nypc-2)=fc(($1)/2+1,nypc-2)+residual($1,nyp-2)/4.0')

define(`RESTRICT_NEAR_NE_ODD',`
C#        `print *,"R (N-NE)",$1,",",$2'
	fc(nxpc-2,nypc-2)=fc(nxpc-2,nypc-2)+residual(nxp-2,nyp-2)/4.0')

define(`RESTRICT_NEAR_EA_ODD',`
C#        `print *,"R (N-EA)",$1,",",$2'
	fc(nxpc-2,($2)/2)=fc(nxpc-2,($2)/2)+residual($1,$2)/4.0
	fc(nxpc-2,($2)/2+1)=fc(nxpc-2,($2)/2+1)+residual($1,$2)/4.0')

define(`RESTRICT_NEAR_SE_ODD',`
C#        `print *,"R (N-SE)",$1,",",$2'
	fc(nxpc-2,1)=fc(nxpc-2,1)+residual(nxp-2,1)/4.0')

define(`RESTRICT_NEAR_SO_ODD',`
C#        `print *,"R (N-SO)",$1,",",$2'
	fc(($1)/2,1)=fc(($1)/2,1)+residual($1,1)/4.0
	fc(($1)/2+1,1)=residual($1,1)/4.0')

define(`RESTRICT_NEAR_SW_ODD',`
C#        `print *,"R (N-SW)",$1,",",$2'
	fc(1,1)=residual(1,1)/4.0')

define(`RESTRICT_NEAR_WE_ODD',`
C#        `print *,"R (N-WE)",$1,",",$2'
	fc(1,($2)/2)=fc(1,($2)/2)+residual(1,$2)/4.0
	fc(1,($2)/2+1)=residual(1,$2)/4.0')

define(`RESTRICT_NEAR_NW_ODD',`
C#        `print *,"R (N-NW)",$1,",",$2'
	fc(1,nypc-2)=fc(1,nypc-2)+residual(1,nyp-2)/4.0')

