include(general.m4)
      PROGRAM testpre
      IMPLICIT NONE

      INTEGER niter,nxp,nyp,nxpc,nypc,padu,padf,paduc,padfc
      PARAMETER (niter=2,nxp=7,nyp=11,nxpc=nxp/2+1,nypc=nyp/2+1)
      PARAMETER (padu=0,padf=0,paduc=0,padfc=0)

      DIME_REAL checksum,omega
      PARAMETER (omega=1.0)

      DIME_REAL coeff(9)
      INTEGER btype(4)
      DIME_REAL u(nxp+padu,nyp)
      DIME_REAL f(nxp+padf,nyp)
      DIME_REAL uc(nxpc+paduc,nypc)
      DIME_REAL fc(nxpc+padfc,nypc)
      DIME_REAL curcheck
      DIME_REAL check

      INTEGER i

      print *,"--------------------"
      print *,"-- Full Weighting --"
      print *,"--------------------"

C---------------------------------------------------------
C     Constante coefficients for 5-point stencil codes ---
C---------------------------------------------------------

      print *,"---------------------"
      print *,"-- 5-point stencil --"
      print *,"---------------------"

      coeff(1)=0.0
      coeff(2)=0.25
      coeff(3)=0.25
      coeff(4)=0.25
      coeff(5)=0.25

C-----------------------------
C     Dirichlet boundaries ---
C-----------------------------

      print *,"--------------------------"
      print *,"-- Dirichlet boundaries --"
      print *,"--------------------------"

      btype(1)=0
      btype(2)=0
      btype(3)=0
      btype(4)=0

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C---------------------------
C     Neumann boundaries ---
C---------------------------

      print *,"------------------------"
      print *,"-- Neumann boundaries --"
      print *,"------------------------"

      btype(1)=1
      btype(2)=1
      btype(3)=1
      btype(4)=1

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C-----------------------------------------
C     Dirichlet and Neumann boundaries ---
C-----------------------------------------

      print *,"----------------------------------------------"
      print *,"-- Dirichlet and Neumann boundaries (NS/EW) --"
      print *,"----------------------------------------------"

      btype(1)=0
      btype(2)=1
      btype(3)=0
      btype(4)=1

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C-----------------------------------------
C     Dirichlet and Neumann boundaries ---
C-----------------------------------------

      print *,"----------------------------------------------"
      print *,"-- Dirichlet and Neumann boundaries (EW/NS) --"
      print *,"----------------------------------------------"

      btype(1)=1
      btype(2)=0
      btype(3)=1
      btype(4)=0

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn5c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C---------------------------------------------------------
C     Constante coefficients for 9-point stencil codes ---
C---------------------------------------------------------

      print *,"---------------------"
      print *,"-- 9-point stencil --"
      print *,"---------------------"

      coeff(1)=0.0
      coeff(2)=0.2
      coeff(3)=0.05
      coeff(4)=0.2
      coeff(5)=0.05
      coeff(6)=0.2
      coeff(7)=0.05
      coeff(8)=0.2
      coeff(9)=0.05

C-----------------------------
C     Dirichlet boundaries ---
C-----------------------------

      print *,"--------------------------"
      print *,"-- Dirichlet boundaries --"
      print *,"--------------------------"

      btype(1)=0
      btype(2)=0
      btype(3)=0
      btype(4)=0

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C---------------------------
C     Neumann boundaries ---
C---------------------------

      print *,"------------------------"
      print *,"-- Neumann boundaries --"
      print *,"------------------------"

      btype(1)=1
      btype(2)=1
      btype(3)=1
      btype(4)=1

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C-----------------------------------------
C     Dirichlet and Neumann boundaries ---
C-----------------------------------------

      print *,"----------------------------------------------"
      print *,"-- Dirichlet and Neumann boundaries (NS/EW) --"
      print *,"----------------------------------------------"

      btype(1)=0
      btype(2)=1
      btype(3)=0
      btype(4)=1

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C-----------------------------------------
C     Dirichlet and Neumann boundaries ---
C-----------------------------------------

      print *,"----------------------------------------------"
      print *,"-- Dirichlet and Neumann boundaries (EW/NS) --"
      print *,"----------------------------------------------"

      btype(1)=1
      btype(2)=0
      btype(3)=1
      btype(4)=0

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL fsn9c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check


      print *,"--------------------"
      print *,"-- Half Injection --"
      print *,"--------------------"

C---------------------------------------------------------
C     Constante coefficients for 5-point stencil codes ---
C---------------------------------------------------------

      print *,"---------------------"
      print *,"-- 5-point stencil --"
      print *,"---------------------"

      coeff(1)=0.0
      coeff(2)=0.25
      coeff(3)=0.25
      coeff(4)=0.25
      coeff(5)=0.25

C-----------------------------
C     Dirichlet boundaries ---
C-----------------------------

      print *,"--------------------------"
      print *,"-- Dirichlet boundaries --"
      print *,"--------------------------"

      btype(1)=0
      btype(2)=0
      btype(3)=0
      btype(4)=0

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C---------------------------
C     Neumann boundaries ---
C---------------------------

      print *,"------------------------"
      print *,"-- Neumann boundaries --"
      print *,"------------------------"

      btype(1)=1
      btype(2)=1
      btype(3)=1
      btype(4)=1

C      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C-----------------------------------------
C     Dirichlet and Neumann boundaries ---
C-----------------------------------------

      print *,"----------------------------------------------"
      print *,"-- Dirichlet and Neumann boundaries (NS/EW) --"
      print *,"----------------------------------------------"

      btype(1)=0
      btype(2)=1
      btype(3)=0
      btype(4)=1

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C-----------------------------------------
C     Dirichlet and Neumann boundaries ---
C-----------------------------------------

      print *,"----------------------------------------------"
      print *,"-- Dirichlet and Neumann boundaries (EW/NS) --"
      print *,"----------------------------------------------"

      btype(1)=1
      btype(2)=0
      btype(3)=1
      btype(4)=0

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn5c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C---------------------------------------------------------
C     Constante coefficients for 9-point stencil codes ---
C---------------------------------------------------------

      print *,"---------------------"
      print *,"-- 9-point stencil --"
      print *,"---------------------"

      coeff(1)=0.0
      coeff(2)=0.2
      coeff(3)=0.05
      coeff(4)=0.2
      coeff(5)=0.05
      coeff(6)=0.2
      coeff(7)=0.05
      coeff(8)=0.2
      coeff(9)=0.05

C-----------------------------
C     Dirichlet boundaries ---
C-----------------------------

      print *,"--------------------------"
      print *,"-- Dirichlet boundaries --"
      print *,"--------------------------"

      btype(1)=0
      btype(2)=0
      btype(3)=0
      btype(4)=0

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C---------------------------
C     Neumann boundaries ---
C---------------------------

      print *,"------------------------"
      print *,"-- Neumann boundaries --"
      print *,"------------------------"

      btype(1)=1
      btype(2)=1
      btype(3)=1
      btype(4)=1

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C-----------------------------------------
C     Dirichlet and Neumann boundaries ---
C-----------------------------------------

      print *,"----------------------------------------------"
      print *,"-- Dirichlet and Neumann boundaries (NS/EW) --"
      print *,"----------------------------------------------"

      btype(1)=0
      btype(2)=1
      btype(3)=0
      btype(4)=1

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C-----------------------------------------
C     Dirichlet and Neumann boundaries ---
C-----------------------------------------

      print *,"----------------------------------------------"
      print *,"-- Dirichlet and Neumann boundaries (EW/NS) --"
      print *,"----------------------------------------------"

      btype(1)=1
      btype(2)=0
      btype(3)=1
      btype(4)=0

      PRINT *,"Fused..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c2(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"1D Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c3(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

      PRINT *,"2D Skewed Blocked..."

      CALL init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      CALL hsn9c4(nxp,nyp,u,padu,f,padf,nxpc,nypc,uc,paduc,fc,padfc,niter,coeff,btype,omega)
      check=checksum(u,nxp,nyp,padu)
      PRINT *,"checksum1:",check
      check=checksum(fc,nxpc,nypc,padfc)
      PRINT *,"checksum2:",check

C------------------
C test finished ---
C------------------
      END
C--------------------------
C     utilitiy routines ---
C--------------------------
      SUBROUTINE init(u,f,nxp,nyp,padu,padf,uc,fc,nxpc,nypc,paduc,padfc)
      INTEGER nxp,nyp,nxpc,nypc,padu,padf,paduc,padfc
      DIME_REAL u(0:nxp+padu-1,0:nyp-1)
      DIME_REAL f(0:nxp+padf-1,0:nyp-1)
      DIME_REAL uc(0:nxpc+paduc-1,0:nypc-1)
      DIME_REAL fc(0:nxpc+padfc-1,0:nypc-1)
      INTEGER i,j

      DO j=0,nyp-1
        DO i=0,nxp+padu-1
          u(i,j)=0.0 
        ENDDO
      ENDDO
      DO j=0,nyp-1
        DO i=0,nxp+padf-1
          f(i,j)=0.0 
        ENDDO
      ENDDO
      DO i=0,nxp-1
        u(i,nyp-1)=(1.0/nxp)*i
        u(i,0)=(1.0/nxp)*(nxp-1-i)
      ENDDO
      DO i=0,nyp-1
        u(nxp-1,i)=(1.0/nyp)*i
        u(0,i)=(1.0/nyp)*(nyp-1-i)
      ENDDO
      DO j=0,nypc-1
        DO i=0,nxpc-1
          uc(i,j)=1.0
          fc(i,j)=1.0
        ENDDO
      ENDDO

      END

      DIME_REAL FUNCTION checksum(u,nxp,nyp,padu)
      IMPLICIT NONE
      INTEGER padu,nxp,nyp
      DIME_REAL u(0:nxp+padu-1,0:nyp-1)
      DIME_REAL c
      INTEGER i,j

      c=0.0
      DO j=0,nyp-1
        DO i=0,nxp-1
          c=c+u(i,j)
        ENDDO
      ENDDO

      checksum=c
      RETURN
      END

      SUBROUTINE show(u,nxp,nyp,padu)
      IMPLICIT NONE
      INTEGER nxp,nyp,padu
      DIME_REAL u(0:nxp+padu-1,0:nyp-1)
      INTEGER i,j

      DO j=0,nyp-1
        DO i=0,nxp-1
          PRINT *,i,j,u(i,j)
        ENDDO
        PRINT *
      ENDDO
      END
