C#-------------------------------------------------------------
C# the macro SUBROUTINE_DIME_RB_5P generates the header for the 
C# 5 point stencil red-black subroutines.
C# Arguments:
C#  1: subroutine name
C# Implicit arguments:
C#  1: subroutine implementation in MACRO RB_KERN
C#  2: relax macro for inner nodes
C#  3: relax macro for boundary nodes
define(`SUBROUTINE_DIME_RB_5P',`
	subroutine $1(nxp,nyp,u,padu,f,padf,niter,coeff,btype)
C#
C# parameter types
C#
	IMPLICIT NONE
	INTEGER niter,nxp,nyp
	DIME_REAL coeff(5)
	INTEGER btype(4)
	INTEGER padu,padf
	DIME_REAL u(0:nxp+padu-1,0:nyp-1)
	DIME_REAL f(0:nxp+padf-1,0:nyp-1)
C#
C# lokal variables
C#
	DIME_REAL ce,no,ea,so,we,r
	INTEGER i,k,x,y,topy
C# setting up coefficients for macro
	ce=coeff(1)
	no=coeff(2)
	ea=coeff(3)
	so=coeff(4)
	we=coeff(5)
C# insert implementation of subroutine
	RB_KERN
	END')
C#-------------------------------------------------------------


C#-------------------------------------------------------------
C# the macro SUBROUTINE_DIME_RB_9P generates the header for the 
C# 9 point stencil red-black subroutines.
C# Arguments:
C#  1: subroutine name
C# Implicit arguments:
C#  1: subroutine implementation in MACRO RB_KERN
C#  2: relax macro for inner nodes
C#  3: relax macro for boundary nodes
define(`SUBROUTINE_DIME_RB_9P',`
	subroutine $1(nxp,nyp,u,padu,f,padf,niter,coeff,btype)
C#
C# parameter types
C#
	IMPLICIT NONE
	INTEGER niter,nxp,nyp
	DIME_REAL coeff(9)
	INTEGER btype(4)
	INTEGER padu,padf
	DIME_REAL u(0:nxp+padu-1,0:nyp-1)
	DIME_REAL f(0:nxp+padf-1,0:nyp-1)
C#
C# lokal variables
C#
	DIME_REAL ce,no,ne,ea,se,so,sw,we,nw
	INTEGER i,k,x,y,topy
C# setting up coefficients for macro
	ce=coeff(1)
	no=coeff(2)
	ne=coeff(3)
	ea=coeff(4)
	se=coeff(5)
	so=coeff(6)
	sw=coeff(7)
	we=coeff(8)
	nw=coeff(9)
C# insert implementation of subroutine
	RB_KERN
	END')
C#-------------------------------------------------------------
